/home/lnzliplg/www/modules.d.zip
PK v��\�w 0� � 98selinux/selinux-loadpolicy.shnu ȯ�� #!/bin/sh
# FIXME: load selinux policy. this should really be done after we switchroot
rd_load_policy()
{
# If SELinux is disabled exit now
getarg "selinux=0" > /dev/null && return 0
SELINUX="enforcing"
[ -e "$NEWROOT/etc/selinux/config" ] && . "$NEWROOT/etc/selinux/config"
# Check whether SELinux is in permissive mode
permissive=0
getarg "enforcing=0" > /dev/null
if [ $? -eq 0 -o "$SELINUX" = "permissive" ]; then
permissive=1
fi
# Attempt to load SELinux Policy
if [ -x "$NEWROOT/usr/sbin/load_policy" -o -x "$NEWROOT/sbin/load_policy" ]; then
local ret=0
local out
info "Loading SELinux policy"
mount -o bind /sys $NEWROOT/sys
# load_policy does mount /proc and /sys/fs/selinux in
# libselinux,selinux_init_load_policy()
if [ -x "$NEWROOT/sbin/load_policy" ]; then
out=$(LANG=C chroot "$NEWROOT" /sbin/load_policy -i 2>&1)
ret=$?
info $out
else
out=$(LANG=C chroot "$NEWROOT" /usr/sbin/load_policy -i 2>&1)
ret=$?
info $out
fi
umount $NEWROOT/sys/fs/selinux
umount $NEWROOT/sys
if [ "$SELINUX" = "disabled" ]; then
return 0;
fi
if [ $ret -eq 0 -o $ret -eq 2 ]; then
# If machine requires a relabel, force to permissive mode
[ -e "$NEWROOT"/.autorelabel ] && LANG=C /usr/sbin/setenforce 0
mount --rbind /dev "$NEWROOT/dev"
LANG=C chroot "$NEWROOT" /sbin/restorecon -R /dev
umount -R "$NEWROOT/dev"
return 0
fi
warn "Initial SELinux policy load failed."
if [ $ret -eq 3 -o $permissive -eq 0 ]; then
warn "Machine in enforcing mode."
warn "Not continuing"
emergency_shell -n selinux
exit 1
fi
return 0
elif [ $permissive -eq 0 -a "$SELINUX" != "disabled" ]; then
warn "Machine in enforcing mode and cannot execute load_policy."
warn "To disable selinux, add selinux=0 to the kernel command line."
warn "Not continuing"
emergency_shell -n selinux
exit 1
fi
}
rd_load_policy
PK v��\Ia��� � 98selinux/module-setup.shnu ȯ�� #!/bin/bash
# called by dracut
check() {
return 255
}
# called by dracut
depends() {
return 0
}
# called by dracut
install() {
inst_hook pre-pivot 50 "$moddir/selinux-loadpolicy.sh"
inst_multiple setenforce
}
PK v��\�}%@� � 95lunmask/parse-lunmask.shnu ȯ�� #!/bin/sh
# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
# ex: ts=8 sw=4 sts=4 et filetype=sh
create_udev_rule() {
local transport=$1
local tgtid=$2
local lun=$3
local _rule=/etc/udev/rules.d/51-${transport}-lunmask-${tgtid}.rules
local _cu_type _dev_type
[ -e ${_rule} ] && return 0
if [ ! -f "$_rule" ] ; then
if [ "$transport" = "fc" ] ; then
cat > $_rule <<EOF
ACTION=="add", SUBSYSTEM=="fc_remote_ports", ATTR{port_name}=="$tgtid", PROGRAM="fc_transport_scan_lun.sh $lun"
EOF
elif [ "$transport" = "sas" ] ; then
cat > $_rule <<EOF
ACTION=="add", SUBSYSTEM=="sas_device", ATTR{sas_address}=="$tgtid", PROGRAM="sas_transport_scan_lun.sh $lun"
EOF
fi
fi
}
for lunmask_arg in $(getargs rd.lunmask); do
(
local OLDIFS="$IFS"
local IFS=","
set $lunmask_arg
IFS="$OLDIFS"
if [ -d /sys/module/scsi_mod ] ; then
printf "manual" > /sys/module/scsi_mod/parameters/scan
elif [ ! -f /etc/modprobe.d/95lunmask.conf ] ; then
echo "options scsi_mod scan=manual" > /etc/modprobe.d/95lunmask.conf
fi
create_udev_rule $1 $2 $3
)
done
PK v��\ЍW`� � 95lunmask/module-setup.shnu ȯ�� #!/bin/bash
# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
# ex: ts=8 sw=4 sts=4 et filetype=sh
# called by dracut
cmdline() {
get_lunmask() {
local _dev=$1
local _devpath=$(cd -P /sys/dev/block/$_dev ; echo $PWD)
local _sdev _lun _rport _end_device _classdev _wwpn _sas_address
[ "${_devpath#*/sd}" == "$_devpath" ] && return 1
_sdev="${_devpath%%/block/*}"
_lun="${_sdev##*:}"
# Check for FibreChannel
_rport="${_devpath##*/rport-}"
if [ "$_rport" != "$_devpath" ] ; then
_rport="${_rport%%/*}"
_classdev="/sys/class/fc_remote_ports/rport-${_rport}"
[ -d "$_classdev" ] || return 1
_wwpn=$(cat ${_classdev}/port_name)
echo "rd.lunmask=fc,${_wwpn},${_lun}"
return 0
fi
# Check for SAS
_end_device="${_devpath##*/end_device-}"
if [ "$_end_device" != "$_devpath" ] ; then
_end_device="${_end_device%%/*}"
_classdev="/sys/class/sas_device/end_device-${_end_device}"
[ -e "$_classdev" ] || return 1
_sas_address=$(cat ${_classdev}/sas_address)
echo "rd.lunmask=sas,${_sas_address},${_lun}"
return 0
fi
return 1
}
[[ $hostonly ]] || [[ $mount_needs ]] && {
for_each_host_dev_and_slaves_all get_lunmask
} | sort | uniq
}
# called by dracut
check() {
[[ $hostonly ]] || [[ $mount_needs ]] && {
[ -w /sys/module/scsi_mod/parameters/scan ] || return 255
scan_type=$(cat /sys/module/scsi_mod/parameters/scan)
[ "$scan_type" = "manual" ] && return 0
return 255
}
return 0
}
# called by dracut
depends() {
return 0
}
# called by dracut
install() {
inst_script "$moddir/fc_transport_scan_lun.sh" /usr/lib/udev/fc_transport_scan_lun.sh
inst_script "$moddir/sas_transport_scan_lun.sh" /usr/lib/udev/sas_transport_scan_lun.sh
inst_hook cmdline 30 "$moddir/parse-lunmask.sh"
if [[ $hostonly_cmdline == "yes" ]] ; then
local _lunmask
for _lunmask in $(cmdline) ; do
printf "%s\n" "$_lunmask" >> "${initdir}/etc/cmdline.d/95lunmask.conf"
done
fi
}
PK v��\�}~G2 2 "